#pragma once
#include "communication/bridge/proxy/i_bridge_connection_status_provider.h"
#include "communication/bridge/proxy/i_tool_connection_status_provider.h"
#include "communication/bridge/proxy/i_program_data_provider.h"
#include "communication/bridge/proxy/i_tool_controller.h"
#include "communication/bridge/proxy/i_bridge_configurator.h"
#include "communication/bridge/proxy/i_bridge_connector.h"
#include "communication/bridge/proxy/i_secondary_bridge_connector.h"

namespace spin
{
    class IBridgeInterfaceProvider
    {
    public:
        virtual ~IBridgeInterfaceProvider() = default;

        virtual std::shared_ptr<IBridgeConnectionStatusProvider> getBridgeConnectionStatusProvider() const = 0;
        virtual std::shared_ptr<IToolConnectionStatusProvider> getToolConnectionStatusProvider() const = 0;
        virtual std::shared_ptr<IProgramDataProvider> getProgramDataProvider() const = 0;
        virtual std::shared_ptr<IToolController> getToolController() const = 0;
        virtual std::shared_ptr<IBridgeConfigurator> getIBridgeConfigurator() const = 0;
        virtual std::shared_ptr<IBridgeConnector> getBridgeConnector() const = 0;
        virtual std::shared_ptr<ISecondaryBridgeConnector> getSecondaryBridgeConnector() const = 0;
    };
} // namespace spin
